#ifndef Transform_H
#define Transform_H

#include <iostream>

using namespace std;

class Transform {

  friend ostream& operator << ( ostream& os, Transform<Type>& a ) {
    a.print( os );
    return os;
  }

  friend ostream& operator << ( ostream& os, Transform<Type>* a ) {
    a->print( os );
    return os;
  }

public:

  enum Axis { XAXIS, YAXIS, ZAXIS };

  enum Dim { num_dim3 = 3, num_dim4 = 4; };

  Transform( ) { init_Transform( transform ); init_Transform( inverse ); }

  Transform( const dvm3_Vector& translation ) { set_translation( translation ); }

  Transform( Axis axis, double theta ) { set_rotation( axis, theta ); }

  void inverse_transformation( const dvm3_Vector& in, dvm3_Vector& out ) {
    transform_position( inverse, in, out );
  }

  void transformation( const dvm3_Vector& in, dvm3_Vector& out ) {
    transform_position( transform, in, out );
  }

  void set_rotation( Axis axis, double theta );

  void set_translation( const dvm3_Vector& translation );

  void print( ostream& os ) const {
    print( os, transform );
    os << '\n';
    print( os, inverse );
  }

protected:

  double transform[ 4 ][ 4 ];
  double inverse[ 4 ][ 4 ];

private:

  void init_Transform( double ptr [][ 4 ] );

  void print( ostream& os, double ptr[][ 4 ] ) const;

  void transform_position( const double ptr[][ 4 ], 
			   const dvm3_Vector& in, dvm3_Vector& out ) const;

};

#endif
