#ifndef dbChipRow_cc
#define dbChipRow_cc

#include "dbChipRow.h"

dbChipRow::dbChipRow( const char* header[], RDBColumn** rdb_column ) 
  throw( Exception ) {

  try {

    double xcpc, ycpc, zcpc;
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 0 ], xcpc );
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 1 ], ycpc );
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 2 ], zcpc );
    cpc = dvm3_Vector( xcpc, ycpc, zcpc );

    double xclip, yclip, zclip=0.0;
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 3 ], xclip );
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 4 ], yclip );
    cpcclip = dvm3_Vector( xclip, yclip, zclip );

    double xlsi, ylsi, zlsi;
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 5 ], xlsi );
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 6 ], ylsi );
    simpleRDBTable<dbChipRow>::getData( rdb_column[ 7 ], zlsi );
    lsi = dvm3_Vector( xlsi, ylsi, zlsi );

    simpleRDBTable<dbChipRow>::getData( rdb_column[ 8 ],
						  identification );

    simpleRDBTable<dbChipRow>::getData( rdb_column[ 9 ], corner );

  } catch( Exception& e ) {

    throw;

  }

}

void dbChipRow::print( ostream& os ) const {

  cpc.print_on( os );
  os << ' ';
  lsi.print_on( os );

}


#endif
