#ifndef dbChipRow_H
#define dbChipRow_H

#include <iostream>

#include <dvm3/dvm3.h>
#include <Exception/Exception.h>
#include <rdbxx/simpleRDBTable.h>

using namespace std;

/**
 * A class to store the row of the parameter chipdb.
 */
class dbChipRow {

  friend ostream& operator << ( ostream& os, dbChipRow& a ) {
    a.print( os );
    return os;
  }

  friend ostream& operator << ( ostream& os, dbChipRow* a ) {
    a->print( os );
    return os;
  }

public:

  virtual ~dbChipRow( ) { }

  dbChipRow( ) { }

  /// The constructor called by the class simpleRDBTable in the RDB++ library.
  dbChipRow( const char* header[], RDBColumn** rdb_column )
    throw( Exception );

  void print( ostream& os ) const;

  /// Get a row from the  `chip' column.
  string get_id( ) const { return identification; }

  /// Get a row from the `corner' column.
  string get_corner( ) const { return corner; }

  /// Get a row from the `xcpc', `ycpc' and `zcpc' column.
  dvm3_Vector get_cpc( ) const { return cpc; }

  /// Get a row from the `xclip', `yclip' and `zclip' column.
  dvm3_Vector get_cpc_clip( ) const { return cpcclip; }

  /// Get a row from the `xlsi', `ylsi' and `zlsi' column.
  dvm3_Vector get_lsi( ) const { return lsi; }

protected:

  string identification, corner;
  dvm3_Vector cpc, cpcclip, lsi;

};

#endif
